import {__decorate,__param,__metadata}from'tslib';import'bunyan';import {Connection}from'mongoose';import {injectable,inject}from'inversify';import {RegistryModelFunc}from'../documents/registry.js';var PublicDockerRegistriesMigration_1;
let PublicDockerRegistriesMigration = PublicDockerRegistriesMigration_1 = class PublicDockerRegistriesMigration {
  logger;
  db;
  model;
  constructor(logger, db) {
    this.logger = logger;
    this.db = db;
    this.logger = logger.child({
      className: PublicDockerRegistriesMigration_1.name
    });
    this.model = RegistryModelFunc(this.db);
  }
  async up() {
    return this.model.create({
      owner_id: 'system',
      name: 'Docker Registry',
      // url: 'https://hub.kubeapps.com', // TODO: Set url to private registery
      credentials: {
        username: '',
        password: '',
        type: 'login-password'
      },
      is_public: true
    });
  }
  async down() {
    // drop any previous templates and create one
    const previousRegistry = await this.model.findOne({
      name: 'Docker Registry',
      owner_id: 'system'
    });
    if (previousRegistry) {
      // drop it
      this.logger.info('Dropping previous template ', previousRegistry.id);
      await this.model.findByIdAndRemove(previousRegistry.id);
    }
  }
};
PublicDockerRegistriesMigration = PublicDockerRegistriesMigration_1 = __decorate([injectable(), __param(0, inject('Logger')), __param(1, inject('MongoDBConnection')), __metadata("design:paramtypes", [Object, Connection])], PublicDockerRegistriesMigration);export{PublicDockerRegistriesMigration};//# sourceMappingURL=PublicRegistries.js.map
