import { IDatabaseMigration } from '@adminide-stack/core';
import { IIResourceUtilizationSettings, IApplicationBillingPlanPolicy } from '@ops-stack/core';
import * as Logger from 'bunyan';
import { ServiceBroker } from 'moleculer';
import { IConfigurationPolicyService } from '@adminide-stack/platform-server';
type IMetadata = Record<IApplicationBillingPlanPolicy, boolean>;
export declare class DockerBillingPlanPoliciesMigration implements IDatabaseMigration {
    private logger;
    private configService;
    protected broker: ServiceBroker;
    private settings;
    constructor(logger: Logger, configService: IConfigurationPolicyService, broker: ServiceBroker, settings: IIResourceUtilizationSettings);
    id: string;
    updatePolicy(tier: string, key: string, value: unknown): Promise<any>;
    static basicMetadata(value: boolean): IMetadata;
    static premiumMetadata(value: boolean): IMetadata;
    static enterpriseMetadata(value: boolean): IMetadata;
    setUpMetadata(tier: string, metadata: Record<IApplicationBillingPlanPolicy, boolean>): Promise<void>;
    setupPlansMetadata(value: boolean): Promise<void>;
    up(): Promise<void>;
    down(): Promise<void>;
}
export {};
//# sourceMappingURL=docker-billing-plan-policies-migration.d.ts.map