import {__decorate,__param,__metadata}from'tslib';import {ServerTypes,generateUri,IConfigCollectionName,IConfigFragmentName}from'@adminide-stack/core';import {IIResourceUtilizationSettings,IApplicationBillingPlanPolicy}from'@ops-stack/core';import {injectable,inject,tagged}from'inversify';import'bunyan';import {CommonType,TaggedType}from'@common-stack/core';import {ServiceBroker}from'moleculer';import {changeIfConfigUriToPolicyUri}from'@adminide-stack/platform-server';import {ITierEnum}from'@adminide-stack/billing-api-core';var DockerBillingPlanPoliciesMigration_1;
var _a;
let DockerBillingPlanPoliciesMigration = DockerBillingPlanPoliciesMigration_1 = class DockerBillingPlanPoliciesMigration {
  logger;
  configService;
  broker;
  settings;
  constructor(logger, configService, broker, settings) {
    this.logger = logger;
    this.configService = configService;
    this.broker = broker;
    this.settings = settings;
    this.logger = logger.child({
      className: DockerBillingPlanPoliciesMigration_1.name
    });
  }
  id = 'DockerBillingPlanPoliciesMigration_06122021';
  async updatePolicy(tier, key, value) {
    const resource = generateUri(IConfigCollectionName.application, {
      name: 'billing'
    }, IConfigFragmentName.billingPlanPolicies);
    const resourceUri = changeIfConfigUriToPolicyUri(resource, false);
    return this.configService.updateValue(resourceUri, key, value, {
      resource,
      overrideIdentifier: tier
    });
  }
  static basicMetadata(value) {
    return {
      [IApplicationBillingPlanPolicy.saasDeployment]: value,
      [IApplicationBillingPlanPolicy.builds]: value,
      [IApplicationBillingPlanPolicy.dockerRepositories]: value,
      [IApplicationBillingPlanPolicy.helmRepositories]: value
    };
  }
  static premiumMetadata(value) {
    return {
      ...DockerBillingPlanPoliciesMigration_1.basicMetadata(value),
      [IApplicationBillingPlanPolicy.kubernetesDashboard]: value,
      [IApplicationBillingPlanPolicy.helmDashboard]: value,
      [IApplicationBillingPlanPolicy.helmRelease]: value,
      [IApplicationBillingPlanPolicy.helmDashboard]: value
    };
  }
  static enterpriseMetadata(value) {
    return {
      ...DockerBillingPlanPoliciesMigration_1.premiumMetadata(value),
      [IApplicationBillingPlanPolicy.dataRetention]: value,
      [IApplicationBillingPlanPolicy.concurrentBuilds]: value,
      [IApplicationBillingPlanPolicy.hybridOrOnPremise]: value,
      [IApplicationBillingPlanPolicy.firewallSupport]: value,
      [IApplicationBillingPlanPolicy.osSupport]: value
    };
  }
  async setUpMetadata(tier, metadata) {
    await Promise.all(Object.entries(metadata).map(([key, value]) => this.updatePolicy(tier, key, value)));
  }
  async setupPlansMetadata(value) {
    await Promise.all(Object.entries({
      [ITierEnum.basic]: DockerBillingPlanPoliciesMigration_1.basicMetadata(value),
      [ITierEnum.premium]: DockerBillingPlanPoliciesMigration_1.premiumMetadata(value),
      [ITierEnum.enterprise]: DockerBillingPlanPoliciesMigration_1.enterpriseMetadata(value)
    }).map(([tier, value]) => this.setUpMetadata(tier, value)));
  }
  async up() {
    await this.setupPlansMetadata(true);
    this.logger.info('Billing Plan Poliices for Docker has been updated');
  }
  async down() {
    await this.setupPlansMetadata(false);
    this.logger.trace('Billing Plan Poliices for Docker has been unset');
  }
};
DockerBillingPlanPoliciesMigration = DockerBillingPlanPoliciesMigration_1 = __decorate([injectable(), __param(0, inject('Logger')), __param(1, inject(ServerTypes.IConfigurationService)), __param(2, inject(CommonType.MOLECULER_BROKER)), __param(3, inject('Settings')), __param(3, tagged(TaggedType.MICROSERVICE, true)), __metadata("design:paramtypes", [Object, Object, ServiceBroker, typeof (_a = typeof IIResourceUtilizationSettings !== "undefined" && IIResourceUtilizationSettings) === "function" ? _a : Object])], DockerBillingPlanPoliciesMigration);export{DockerBillingPlanPoliciesMigration};//# sourceMappingURL=docker-billing-plan-policies-migration.js.map
