const resolvers = () => ({
  Query: {
    dockerCatalog: (root, args, {
      dataSources
    }) => dataSources.registry.registry(),
    imageTags: (root, {
      image
    }, {
      dataSources
    }) => dataSources.registry.imageTags(image),
    dockerImages: (root, args, {
      dataSources
    }) => dataSources.registry.containers(),
    dockerSearch: (root, {
      request
    }, {
      dataSources
    }) => dataSources.registry.search(request),
    allDockerRegistries: async (root, args, context) => {
      return await context.dockerRegistryManager.allDockerRegistries();
    },
    dockerRegistryImageTags: async (root, {
      registry,
      image
    }, context) => {
      const obj = await context.dockerRegistryManager.find(registry);
      return context.dockerRegistry.imageTags(obj.url, image);
    },
    dockerRegistryCatalog: async (root, {
      registry
    }, context) => {
      const obj = await context.dockerRegistryManager.find(registry);
      try {
        return context.dockerRegistry.registry(obj.url);
      } catch (e) {
        console.log('Catch error:', e);
        return {
          repositories: []
        };
      }
    },
    getDockerRegistry: (root, {
      _id
    }, context) => {
      return context.dockerRegistryManager.find(_id);
    },
    testDockerRegistry: (root, {
      payload
    }, {
      dockerRegistryManager
    }) => dockerRegistryManager.test(payload)
  },
  Mutation: {
    createDockerRegistry: (root, {
      payload
    }, {
      dockerRegistry,
      dockerRegistryManager,
      user
    }) => {
      return dockerRegistryManager.createRegistry({
        ...payload
      });
    },
    updateDockerRegistry: (root, {
      id,
      payload
    }, {
      dockerRegistry,
      dockerRegistryManager
    }) => dockerRegistryManager.updateRegistry(id, payload),
    removeDockerRegistry: (root, {
      id
    }, {
      dockerRegistry,
      dockerRegistryManager
    }) => dockerRegistryManager.removeRegistry(id)
  }
});export{resolvers};//# sourceMappingURL=index.js.map
