import {__decorate,__metadata}from'tslib';import {resolve}from'url';import*as qs from'query-string';import {injectable}from'inversify';import Axios from'axios';import {REGISTRY_ROUTES}from'./constants.js';let Registry = class Registry {
  http;
  constructor() {
    this.http = Axios.create();
  }
  routes = {
    [REGISTRY_ROUTES.REGISTRY]: () => `/v2/_catalog`,
    [REGISTRY_ROUTES.CONTAINERS]: () => `/images/json`,
    [REGISTRY_ROUTES.TAGS]: ({
      image
    }) => `/v2/${image}/tags/list`,
    [REGISTRY_ROUTES.SEARCH]: ({
      request
    }) => `/images/search?${qs.stringify({
      ...request,
      filters: qs.stringify(request.filters || {})
    })}`
  };
  endpoint(url, route, input, identity) {
    const fn = this.routes[route];
    const api = fn(input, identity);
    return resolve(url, api);
  }
  headers(...data) {
    return {};
  }
  async request(url, route, input, options = {}) {
    const endpoint = this.endpoint(url, route, input);
    try {
      const response = await this.http.get(endpoint, {
        headers: this.headers(options)
      }).then(({
        data
      }) => data);
      return options.fetch ? options.fetch(response) : response;
    } catch (e) {
      console.error(e);
      return {};
    }
  }
  async search(url, request) {
    return this.request(url, REGISTRY_ROUTES.SEARCH, {
      request
    });
  }
  async registry(url) {
    return this.request(url, REGISTRY_ROUTES.REGISTRY, {});
  }
  async imageTags(url, image) {
    return this.request(url, REGISTRY_ROUTES.TAGS, {
      image
    });
  }
  async containers(url) {
    return this.request(url, REGISTRY_ROUTES.CONTAINERS, {});
  }
};
Registry = __decorate([injectable(), __metadata("design:paramtypes", [])], Registry);export{Registry};//# sourceMappingURL=Registry.js.map
