import * as Logger from 'bunyan';
import { Model, Connection } from 'mongoose';
import { IRegistryManagementService, IDockerRegistry } from '../interfaces';
export declare class RegistryManagement implements IRegistryManagementService {
    model: Model<any>;
    basicURL: string;
    constructor(logger: Logger, db: Connection);
    routes: {
        "REGISTRY/CREATE": () => string;
        "REGISTRY/UPDATE": ({ id }: {
            id: any;
        }) => string;
        "REGISTRY/REMOVE": ({ id }: {
            id: any;
        }) => string;
        REGISTRIES: () => string;
    };
    endpoint(route: any, input?: any): any;
    authHeader(): {
        auth: {
            username: string;
            password: string;
        };
    };
    createRegistry(payload: IDockerRegistry): Promise<boolean>;
    updateRegistry(id: any, payload: IDockerRegistry): Promise<boolean>;
    removeRegistry(id: any): Promise<boolean>;
    allDockerRegistries(): Promise<{}>;
    create(payload: IDockerRegistry): Promise<IDockerRegistry>;
    update(id: any, payload: IDockerRegistry): Promise<IDockerRegistry>;
    list(owner_id: string): Promise<IDockerRegistry[]>;
    find(_id: string): Promise<IDockerRegistry>;
    remove(_id: string): Promise<boolean>;
    test({ url, credentials }: {
        url: any;
        credentials: any;
    }): Promise<boolean>;
}
//# sourceMappingURL=RegistryManagement.d.ts.map