import { RESTDataSource, RequestOptions } from 'apollo-datasource-rest';
import { IDockerRegistryService, ISearchRequest } from '../interfaces';
export declare enum REGISTRY_ROUTES {
    TAGS = "tags",
    SEARCH = "search",
    REGISTRY = "registry",
    CONTAINERS = "containers",
    REGISTRIES = "REGISTRIES"
}
export declare class RegistryService extends RESTDataSource implements IDockerRegistryService {
    baseURL: string;
    apiURL: string;
    willSendRequest(request: RequestOptions): void;
    routes: {
        registry: () => string;
        containers: () => string;
        tags: ({ image }: {
            image: any;
        }) => string;
        search: ({ request }: {
            request: any;
        }) => string;
    };
    resolveURL(request: RequestOptions): Promise<any>;
    endpoint(route: any, input: any, identity?: any): any;
    headers(...data: any[]): {};
    request(route: any, input: any, options?: any): Promise<any>;
    search(request: ISearchRequest): Promise<any>;
    registry(): Promise<any>;
    imageTags(image: string): Promise<any>;
    containers(): Promise<any>;
}
//# sourceMappingURL=RegistryService.d.ts.map