import*as qs from'query-string';import {config}from'../config/env-config.js';import {RESTDataSource}from'apollo-datasource-rest';var REGISTRY_ROUTES;
(function (REGISTRY_ROUTES) {
  REGISTRY_ROUTES["TAGS"] = "tags";
  REGISTRY_ROUTES["SEARCH"] = "search";
  REGISTRY_ROUTES["REGISTRY"] = "registry";
  REGISTRY_ROUTES["CONTAINERS"] = "containers";
  REGISTRY_ROUTES["REGISTRIES"] = "REGISTRIES";
})(REGISTRY_ROUTES || (REGISTRY_ROUTES = {}));
const encode = str => Buffer.from(str, 'binary').toString('base64');
class RegistryService extends RESTDataSource {
  baseURL = 'http://admin:PrepTrain2016@registery.dev.cdebase.com';
  apiURL = config.HARBOR_BASE_URI;
  willSendRequest(request) {
    const basicToken = 'Basic ' + encode(`${config.HARBOR_API_USER}:${config.HARBOR_API_PASSWORD}`);
    request.headers.set('Authorization', basicToken);
  }
  routes = {
    [REGISTRY_ROUTES.REGISTRY]: () => `/v2/_catalog`,
    [REGISTRY_ROUTES.CONTAINERS]: () => `/images/json`,
    [REGISTRY_ROUTES.TAGS]: ({
      image
    }) => `/v2/${image}/tags/list`,
    [REGISTRY_ROUTES.SEARCH]: ({
      request
    }) => `/images/search?${qs.stringify({
      ...request,
      filters: qs.stringify(request.filters || {})
    })}`
  };
  async resolveURL(request) {
    return super.resolveURL(request);
  }
  endpoint(route, input, identity) {
    const fn = this.routes[route];
    const api = fn(input, identity);
    return api;
  }
  headers(...data) {
    return {};
  }
  async request(route, input, options = {}) {
    const endpoint = this.endpoint(route, input);
    try {
      const response = await this.get(endpoint, {}, {
        headers: this.headers(options)
      });
      return options.fetch ? options.fetch(response) : response;
    } catch (e) {
      console.error(e);
      return {};
    }
  }
  async search(request) {
    return this.request(REGISTRY_ROUTES.SEARCH, {
      request
    });
  }
  async registry() {
    return this.request(REGISTRY_ROUTES.REGISTRY, {});
  }
  async imageTags(image) {
    return this.request(REGISTRY_ROUTES.TAGS, {
      image
    });
  }
  async containers() {
    return this.request(REGISTRY_ROUTES.CONTAINERS, {});
  }
}export{REGISTRY_ROUTES,RegistryService};//# sourceMappingURL=RegistryService.js.map
