var schema = "type DockerImage {\n    Id: ID!\n    Os: String\n    Size: Float\n    Author: String\n    Parent: String\n    Created: String\n    Comment: String\n    Container: String\n    RepoTags: [String]\n    VirtualSize: Float\n    Architecture: String\n    RepoDigests: [String]\n    DockerVersion: String\n    RootFS: DockerRootFS\n    Config: DokerImageConfig\n    ContainerConfig: DockerContainerConfig\n    GraphDriver: DockerContainerGraphDriver\n}\n\ntype DokerImageConfig {\n    Image: String\n    NetworkDisabled: Boolean\n    StdinOnce: Boolean\n    PublishService: String\n    AttachStdin: Boolean\n    OpenStdin: Boolean\n    Domainname: String\n    AttachStdout: Boolean\n    Tty: Boolean\n    Hostname: String\n    Cmd: [String]\n    Env: [String]\n    MacAddress: String\n    AttachStderr: Boolean\n    WorkingDir: String\n    User: String\n}\n\ntype DockerContainerGraphDriver {\n    Name: String\n}\n\ntype DockerContainerConfig {\n    Tty: Boolean\n    Hostname: String\n    Domainname: String\n    AttachStdout: Boolean\n    PublishService: String\n    AttachStdin: Boolean\n    OpenStdin: Boolean\n    StdinOnce: Boolean\n    NetworkDisabled: Boolean\n    Image: String\n    User: String\n    WorkingDir: String\n    MacAddress: String\n    AttachStderr: Boolean\n    Env: [String]\n    Cmd: [String]\n}\n\ntype DockerRootFS {\n    Layers: [String]\n}\n\ntype DockerSearchObject {\n    name: String\n    star_count: Int\n    description: String\n    is_official: Boolean\n    is_automated: Boolean\n}\n\ntype DockerListItem {\n    Id: String\n    Size: Float\n    Created: Float\n    ParentId: String\n    SharedSize: Float\n    RepoTags: [String]\n    Containers: Float\n    VirtualSize: Float\n    RepoDigests: [String]\n}\n\ninput IDockerSearchFilter {\n    prop: String\n    value: String\n}\n\ninput IDockerSearchRequest {\n    limit: Int\n    term: String!\n    filters: [IDockerSearchFilter]\n}\n\ntype RegistryCatalog {\n    repositories: [String]\n}\n\ntype ImageTags {\n    name: String!\n    tags: [String]\n}\n\ntype DockerRegistry {\n    id: ID!\n    url: String\n    name: String\n    type: String\n    description: String\n}\n\ninput IDockerRegistry {\n    url: String\n    name: String\n    type: String\n    description: String\n    access_key: String\n    access_secret: String\n    credentials_type: String\n}\n\n\nextend type Query {\n    dockerImages: [DockerListItem]\n    dockerCatalog: RegistryCatalog\n    imageTags(image: ID!): ImageTags\n    testDockerRegistry(payload: IDockerRegistry): Boolean\n    dockerSearch(request: IDockerSearchRequest!): [DockerSearchObject] \n\n    dockerRegistryImages(registry: String!): [DockerListItem]\n    dockerRegistryCatalog(registry: String!): RegistryCatalog\n    dockerRegistryImageTags(registry: String!, image: ID!): ImageTags\n    dockerRegistrySearch(registry: String!, request: IDockerSearchRequest!): [DockerSearchObject] \n\n    allDockerRegistries: [DockerRegistry]\n    getDockerRegistry(_id: ID!): DockerRegistry\n}\n\nextend type Mutation {\n    removeDockerRegistry(id: ID): Boolean\n    createDockerRegistry(payload: IDockerRegistry): Boolean\n    updateDockerRegistry(id: ID!, payload: IDockerRegistry): Boolean\n}\n";export{schema as default};//# sourceMappingURL=typeDefs.graphql.js.map
